"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { newObj[key] = obj[key]; } } } newObj.default = obj; return newObj; } } function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }// src/index.ts
var _pbkdf2 = require('pbkdf2'); var deriveKey = _interopRequireWildcard(_pbkdf2);
var _crypto = require('crypto'); var _crypto2 = _interopRequireDefault(_crypto);
var _tschacha20 = require('ts-chacha20');
function pbkdf2({ password, salt }) {
  return deriveKey.pbkdf2Sync(password, salt, 1, 64, "sha256");
}
function generateRandom(length = 16) {
  return Uint8Array.from(_crypto2.default.randomBytes(length));
}
function aesEncrypt(data, password) {
  const salt = generateRandom(12);
  const key = pbkdf2({ password, salt });
  const encrypt = new (0, _tschacha20.Chacha20)(key.subarray(0, 32), salt).encrypt(
    Buffer.from(data, "utf8")
  );
  const packaged = Buffer.concat([salt, encrypt]);
  return packaged.toString("base64");
}
function aesDecrypt(data, password) {
  const unpackaged = Buffer.from(data, "base64");
  const salt = unpackaged.subarray(0, 12);
  const input = unpackaged.subarray(12, data.length);
  console.log(JSON.stringify(salt));
  const key = pbkdf2({ password, salt });
  console.log(JSON.stringify(key));
  const message = new (0, _tschacha20.Chacha20)(key.subarray(0, 32), salt).decrypt(input);
  console.log(message);
  return Buffer.from(message).toString("utf8");
}




exports.aesDecrypt = aesDecrypt; exports.aesEncrypt = aesEncrypt; exports.pbkdf2 = pbkdf2;
