// src/index.ts
import * as deriveKey from "pbkdf2";
import crypto from "crypto";
import { Chacha20 } from "ts-chacha20";
function pbkdf2({ password, salt }) {
  return deriveKey.pbkdf2Sync(password, salt, 1, 64, "sha256");
}
function generateRandom(length = 16) {
  return Uint8Array.from(crypto.randomBytes(length));
}
function aesEncrypt(data, password) {
  const salt = generateRandom(12);
  const key = pbkdf2({ password, salt });
  const encrypt = new Chacha20(key.subarray(0, 32), salt).encrypt(
    Buffer.from(data, "utf8")
  );
  const packaged = Buffer.concat([salt, encrypt]);
  return packaged.toString("base64");
}
function aesDecrypt(data, password) {
  const unpackaged = Buffer.from(data, "base64");
  const salt = unpackaged.subarray(0, 12);
  const input = unpackaged.subarray(12, data.length);
  console.log(JSON.stringify(salt));
  const key = pbkdf2({ password, salt });
  console.log(JSON.stringify(key));
  const message = new Chacha20(key.subarray(0, 32), salt).decrypt(input);
  console.log(message);
  return Buffer.from(message).toString("utf8");
}
export {
  aesDecrypt,
  aesEncrypt,
  pbkdf2
};
